//
// ccsdpr12_c.cc
//
// Copyright (C) 2009 Toru Shiozaki
//
// Author: Toru Shiozaki <shiozaki.toru@gmail.com>
// Maintainer: TS
//
// This file is part of the SC Toolkit.
//
// The SC Toolkit is free software; you can redistribute it and/or modifd2
// it under the terms of the GNU Library General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// The SC Toolkit is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public License
// along with the SC Toolkit; see the file COPYING.LIB.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// The U.S. Government is granted a limited license as per AL 91-7.
//
  
// This is a C++ code generated by SMITH
  
#include <algorithm>
#include <chemistry/qc/ccr12/ccsdpr12_c.h>
#include <chemistry/qc/ccr12/tensor.h>
using namespace sc;
  
  
CCSDPR12_C::CCSDPR12_C(CCR12_Info* info):z(info){};
CCSDPR12_C::~CCSDPR12_C(){};
  
  
  
void CCSDPR12_C::compute_amp(Ref<Tensor>& out){ //k_i0_offset,z->bs2(),z->gt2(),z->f1(),z->fd2(),z->in.at(0),z->t1(),z->t2(),z->v2(),z->vd2()=>z->xs2()
  
in.resize(8);
  
in.at(1)=new Tensor("ccsdpr12_c_1_0",z->mem());
offset_smith_0_1();
smith_0_1_0(); //z->vd2()=>in.at(1)
in.at(2)=new Tensor("ccsdpr12_c_2_0",z->mem());
offset_smith_1_1();
smith_1_1_0(); //z->f1()=>in.at(2)
smith_2_12(); //z->t1(),z->v2()=>in.at(2)
smith_1_1(); //z->fd2(),in.at(2)=>in.at(1)
delete in.at(2);
in.at(2)=new Tensor("ccsdpr12_c_2_14",z->mem());
offset_smith_1_14();
smith_2_14(); //z->t1(),z->fd2()=>in.at(2)
smith_1_14(); //z->v2(),in.at(2)=>in.at(1)
delete in.at(2);
smith_0_1(out); //z->t2(),in.at(1)=>out
delete in.at(1);
in.at(1)=new Tensor("ccsdpr12_c_1_2",z->mem());
offset_smith_0_2();
smith_1_2(); //z->gt2(),z->f1()=>in.at(1)
smith_0_2(out); //z->xs2(),in.at(1)=>out
delete in.at(1);
smith_0_3(out); //z->gt2(),z->bs2()=>out
smith_0_4(out); //z->vd2()=>out
in.at(1)=new Tensor("ccsdpr12_c_1_5",z->mem());
offset_smith_0_5();
smith_1_5(); //z->t1(),z->fd2()=>in.at(1)
smith_0_5(out); //z->v2(),in.at(1)=>out
delete in.at(1);
in.at(1)=new Tensor("ccsdpr12_c_1_1",z->mem());
offset_smith_0_6();
smith_0_6_0(); //z->vd2()=>in.at(1)
in.at(2)=new Tensor("ccsdpr12_c_2_7",z->mem());
offset_smith_1_7();
smith_2_7(); //z->t1(),z->fd2()=>in.at(2)
smith_1_7(); //z->v2(),in.at(2)=>in.at(1)
delete in.at(2);
smith_1_8(); //z->t1(),z->vd2()=>in.at(1)
smith_0_6(out); //z->t1(),in.at(1)=>out
delete in.at(1);
in.at(1)=new Tensor("ccsdpr12_c_1_2",z->mem());
offset_smith_0_9();
in.at(2)=new Tensor("ccsdpr12_c_2_0",z->mem());
offset_smith_1_9();
smith_1_9_0(); //z->v2()=>in.at(2)
smith_2_13(); //z->t1(),z->v2()=>in.at(2)
smith_1_9(); //z->t2(),in.at(2)=>in.at(1)
delete in.at(2);
in.at(2)=new Tensor("ccsdpr12_c_2_11",z->mem());
offset_smith_1_11();
in.at(3)=new Tensor("ccsdpr12_c_3_11",z->mem());
offset_smith_2_11();
smith_3_11(); //z->t1(),z->v2()=>in.at(3)
smith_2_11(); //z->t1(),in.at(3)=>in.at(2)
delete in.at(3);
smith_1_11(); //z->t1(),in.at(2)=>in.at(1)
delete in.at(2);
smith_0_9(out); //z->fd2(),in.at(1)=>out
delete in.at(1);
  
}
  
void CCSDPR12_C::smith_0_1(Ref<Tensor>& out){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h1b=0L;h1b<z->noab();++h1b) { 
   for (long h2b=h1b;h2b<z->noab();++h2b) { 
    long tileoffset; 
    tileoffset=(h2b+z->noab()*(h1b+z->noab()*(h4b+z->noab()*(h3b)))); 
    if (out->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h1b)+z->get_spin(h2b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h1b)^z->get_sym(h2b))))==(z->irrep_t()^(z->irrep_e()^z->irrep_f()))) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h1b)*z->get_range(h2b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long p5b=z->noab();p5b<z->noab()+z->nvab();++p5b) { 
         for (long p6b=p5b;p6b<z->noab()+z->nvab();++p6b) { 
          if (z->get_spin(p5b)+z->get_spin(p6b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
           if ((z->get_sym(p5b)^(z->get_sym(p6b)^(z->get_sym(h1b)^z->get_sym(h2b))))==z->irrep_t()) { 
            long p5b_0,p6b_0,h1b_0,h2b_0; 
            z->restricted_4(p5b,p6b,h1b,h2b,p5b_0,p6b_0,h1b_0,h2b_0); 
            long h3b_1,h4b_1,p5b_1,p6b_1; 
            z->restricted_4(h3b,h4b,p5b,p6b,h3b_1,h4b_1,p5b_1,p6b_1); 
            long dim_common=z->get_range(p5b)*z->get_range(p6b); 
            long dima0_sort=z->get_range(h1b)*z->get_range(h2b); 
            long dima0=dim_common*dima0_sort; 
            long dima1_sort=z->get_range(h3b)*z->get_range(h4b); 
            long dima1=dim_common*dima1_sort; 
            z->t2()->get_block(h2b_0+z->noab()*(h1b_0+z->noab()*(p6b_0-z->noab()+z->nvab()*(p5b_0-z->noab()))),k_a0); 
            z->sort_indices4(k_a0,k_a0_sort,z->get_range(p5b),z->get_range(p6b),z->get_range(h1b),z->get_range(h2b),3,2,1,0,+1.0); 
            in[1]->get_block(p6b_1-z->noab()+z->nvab()*(p5b_1-z->noab()+z->nvab()*(h4b_1+z->noab()*(h3b_1))),k_a1); 
            z->sort_indices4(k_a1,k_a1_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(p5b),z->get_range(p6b),1,0,3,2,+1.0); 
            double factor=1.0; 
            if (p5b==p6b) { 
             factor=factor/2.0; 
            } 
            z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
           } 
          } 
         } 
        } 
        z->sort_indices4(k_c_sort,k_c,z->get_range(h4b),z->get_range(h3b),z->get_range(h2b),z->get_range(h1b),1,0,3,2,+0.5/0.5); 
        out->add_block(h2b+z->noab()*(h1b+z->noab()*(h4b+z->noab()*(h3b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_0_1_0(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long p5b=z->noab();p5b<z->noab()+z->nvab();++p5b) { 
   for (long p6b=p5b;p6b<z->noab()+z->nvab();++p6b) { 
    long tileoffset; 
    tileoffset=(p6b-z->noab()+z->nvab()*(p5b-z->noab()+z->nvab()*(h4b+z->noab()*(h3b)))); 
    if (in[1]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(p5b)+z->get_spin(p6b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(p5b)+z->get_spin(p6b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(p5b)^z->get_sym(p6b))))==(z->irrep_e()^z->irrep_f())) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(p5b)*z->get_range(p6b); 
        std::fill(k_c,k_c+dimc,0.0); 
        long h3b_0,h4b_0,p5b_0,p6b_0; 
        z->restricted_4(h3b,h4b,p5b,p6b,h3b_0,h4b_0,p5b_0,p6b_0); 
        long dim_common=1L; 
        long dima0_sort=z->get_range(h3b)*z->get_range(h4b)*z->get_range(p5b)*z->get_range(p6b); 
        long dima0=dim_common*dima0_sort; 
        z->vd2()->get_block(p6b_0+(z->nab())*(p5b_0+(z->nab())*(h4b_0+z->noab()*(h3b_0))),k_a0); 
        z->sort_indices4(k_a0,k_a0_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(p5b),z->get_range(p6b),0,1,2,3,+1.0); 
        z->sort_indices4(k_a0_sort,k_c,z->get_range(h3b),z->get_range(h4b),z->get_range(p5b),z->get_range(p6b),0,1,2,3,+1.0); 
        in[1]->add_block(p6b-z->noab()+z->nvab()*(p5b-z->noab()+z->nvab()*(h4b+z->noab()*(h3b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_c); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::offset_smith_0_1(){ 
 
long size=0L; 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long p5b=z->noab();p5b<z->noab()+z->nvab();++p5b) { 
   for (long p6b=p5b;p6b<z->noab()+z->nvab();++p6b) { 
    if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(p5b)+z->get_spin(p6b)) { 
     if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(p5b)^z->get_sym(p6b))))==(z->irrep_e()^z->irrep_f())) { 
      if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(p5b)+z->get_spin(p6b)!=8L) { 
       in[1]->input_offset(p6b-z->noab()+z->nvab()*(p5b-z->noab()+z->nvab()*(h4b+z->noab()*(h3b))),size); 
       size+=z->get_range(h3b)*z->get_range(h4b)*z->get_range(p5b)*z->get_range(p6b); 
      } 
     } 
    } 
   } 
  } 
 } 
} 
in[1]->set_filesize(size); 
in[1]->createfile(); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_0_2(Ref<Tensor>& out){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h1b=0L;h1b<z->noab();++h1b) { 
   for (long h2b=h1b;h2b<z->noab();++h2b) { 
    long tileoffset; 
    tileoffset=(h2b+z->noab()*(h1b+z->noab()*(h4b+z->noab()*(h3b)))); 
    if (out->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h1b)+z->get_spin(h2b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h1b)^z->get_sym(h2b))))==(z->irrep_e()^(z->irrep_t()^z->irrep_f()))) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h1b)*z->get_range(h2b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long h5b=0L;h5b<z->noab();++h5b) { 
         for (long h6b=h5b;h6b<z->noab();++h6b) { 
          if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h5b)+z->get_spin(h6b)) { 
           if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h5b)^z->get_sym(h6b))))==z->irrep_e()) { 
            long h3b_0,h4b_0,h5b_0,h6b_0; 
            z->restricted_4(h3b,h4b,h5b,h6b,h3b_0,h4b_0,h5b_0,h6b_0); 
            long h5b_1,h6b_1,h1b_1,h2b_1; 
            z->restricted_4(h5b,h6b,h1b,h2b,h5b_1,h6b_1,h1b_1,h2b_1); 
            long dim_common=z->get_range(h5b)*z->get_range(h6b); 
            long dima0_sort=z->get_range(h3b)*z->get_range(h4b); 
            long dima0=dim_common*dima0_sort; 
            long dima1_sort=z->get_range(h1b)*z->get_range(h2b); 
            long dima1=dim_common*dima1_sort; 
            z->xs2()->get_block(h6b_0+z->noab()*(h5b_0+z->noab()*(h4b_0+z->noab()*(h3b_0))),k_a0); 
            z->sort_indices4(k_a0,k_a0_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(h5b),z->get_range(h6b),1,0,3,2,+1.0); 
            in[1]->get_block(h2b_1+z->noab()*(h1b_1+z->noab()*(h6b_1+z->noab()*(h5b_1))),k_a1); 
            z->sort_indices4(k_a1,k_a1_sort,z->get_range(h5b),z->get_range(h6b),z->get_range(h1b),z->get_range(h2b),3,2,1,0,+1.0); 
            double factor=1.0; 
            if (h5b==h6b) { 
             factor=factor/2.0; 
            } 
            z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
           } 
          } 
         } 
        } 
        z->sort_indices4(k_c_sort,k_c,z->get_range(h2b),z->get_range(h1b),z->get_range(h4b),z->get_range(h3b),3,2,1,0,+0.5/0.5); 
        out->add_block(h2b+z->noab()*(h1b+z->noab()*(h4b+z->noab()*(h3b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::offset_smith_0_2(){ 
 
long size=0L; 
for (long h5b=0L;h5b<z->noab();++h5b) { 
 for (long h6b=h5b;h6b<z->noab();++h6b) { 
  for (long h1b=0L;h1b<z->noab();++h1b) { 
   for (long h2b=h1b;h2b<z->noab();++h2b) { 
    if (z->get_spin(h5b)+z->get_spin(h6b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
     if ((z->get_sym(h5b)^(z->get_sym(h6b)^(z->get_sym(h1b)^z->get_sym(h2b))))==(z->irrep_t()^z->irrep_f())) { 
      if (!z->restricted() || z->get_spin(h5b)+z->get_spin(h6b)+z->get_spin(h1b)+z->get_spin(h2b)!=8L) { 
       in[1]->input_offset(h2b+z->noab()*(h1b+z->noab()*(h6b+z->noab()*(h5b))),size); 
       size+=z->get_range(h5b)*z->get_range(h6b)*z->get_range(h1b)*z->get_range(h2b); 
      } 
     } 
    } 
   } 
  } 
 } 
} 
in[1]->set_filesize(size); 
in[1]->createfile(); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_0_3(Ref<Tensor>& out){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h1b=0L;h1b<z->noab();++h1b) { 
   for (long h2b=h1b;h2b<z->noab();++h2b) { 
    long tileoffset; 
    tileoffset=(h2b+z->noab()*(h1b+z->noab()*(h4b+z->noab()*(h3b)))); 
    if (out->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h1b)+z->get_spin(h2b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h1b)^z->get_sym(h2b))))==(z->irrep_t()^z->irrep_e())) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h1b)*z->get_range(h2b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long h5b=0L;h5b<z->noab();++h5b) { 
         for (long h6b=h5b;h6b<z->noab();++h6b) { 
          if (z->get_spin(h5b)+z->get_spin(h6b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
           if ((z->get_sym(h5b)^(z->get_sym(h6b)^(z->get_sym(h1b)^z->get_sym(h2b))))==z->irrep_t()) { 
            long h5b_0,h6b_0,h1b_0,h2b_0; 
            z->restricted_4(h5b,h6b,h1b,h2b,h5b_0,h6b_0,h1b_0,h2b_0); 
            long h3b_1,h4b_1,h5b_1,h6b_1; 
            z->restricted_4(h3b,h4b,h5b,h6b,h3b_1,h4b_1,h5b_1,h6b_1); 
            long dim_common=z->get_range(h5b)*z->get_range(h6b); 
            long dima0_sort=z->get_range(h1b)*z->get_range(h2b); 
            long dima0=dim_common*dima0_sort; 
            long dima1_sort=z->get_range(h3b)*z->get_range(h4b); 
            long dima1=dim_common*dima1_sort; 
            z->gt2()->get_block(h2b_0+z->noab()*(h1b_0+z->noab()*(h6b_0+z->noab()*(h5b_0))),k_a0); 
            z->sort_indices4(k_a0,k_a0_sort,z->get_range(h5b),z->get_range(h6b),z->get_range(h1b),z->get_range(h2b),3,2,1,0,+1.0); 
            z->bs2()->get_block(h6b_1+z->noab()*(h5b_1+z->noab()*(h4b_1+z->noab()*(h3b_1))),k_a1); 
            z->sort_indices4(k_a1,k_a1_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(h5b),z->get_range(h6b),1,0,3,2,+1.0); 
            double factor=1.0; 
            if (h5b==h6b) { 
             factor=factor/2.0; 
            } 
            z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
           } 
          } 
         } 
        } 
        z->sort_indices4(k_c_sort,k_c,z->get_range(h4b),z->get_range(h3b),z->get_range(h2b),z->get_range(h1b),1,0,3,2,+0.5/0.5); 
        out->add_block(h2b+z->noab()*(h1b+z->noab()*(h4b+z->noab()*(h3b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_0_4(Ref<Tensor>& out){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h1b=0L;h1b<z->noab();++h1b) { 
   for (long h2b=h1b;h2b<z->noab();++h2b) { 
    long tileoffset; 
    tileoffset=(h2b+z->noab()*(h1b+z->noab()*(h4b+z->noab()*(h3b)))); 
    if (out->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h1b)+z->get_spin(h2b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h1b)^z->get_sym(h2b))))==z->irrep_e()) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h1b)*z->get_range(h2b); 
        std::fill(k_c,k_c+dimc,0.0); 
        long h3b_0,h4b_0,h1b_0,h2b_0; 
        z->restricted_4(h3b,h4b,h1b,h2b,h3b_0,h4b_0,h1b_0,h2b_0); 
        long dim_common=1L; 
        long dima0_sort=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h1b)*z->get_range(h2b); 
        long dima0=dim_common*dima0_sort; 
        z->vd2()->get_block(h2b_0+(z->nab())*(h1b_0+(z->nab())*(h4b_0+z->noab()*(h3b_0))),k_a0); 
        z->sort_indices4(k_a0,k_a0_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(h1b),z->get_range(h2b),0,1,2,3,+1.0); 
        z->sort_indices4(k_a0_sort,k_c,z->get_range(h3b),z->get_range(h4b),z->get_range(h1b),z->get_range(h2b),0,1,2,3,+1.0); 
        out->add_block(h2b+z->noab()*(h1b+z->noab()*(h4b+z->noab()*(h3b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_c); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_0_5(Ref<Tensor>& out){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h1b=0L;h1b<z->noab();++h1b) { 
   for (long h2b=h1b;h2b<z->noab();++h2b) { 
    long tileoffset; 
    tileoffset=(h2b+z->noab()*(h1b+z->noab()*(h4b+z->noab()*(h3b)))); 
    if (out->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h1b)+z->get_spin(h2b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h1b)^z->get_sym(h2b))))==(z->irrep_v()^(z->irrep_t()^z->irrep_e()))) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h1b)*z->get_range(h2b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long h5b=0L;h5b<z->noab();++h5b) { 
         for (long q6b=z->noab()+z->nvab();q6b<z->nab();++q6b) { 
          if (z->get_spin(h5b)+z->get_spin(q6b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
           if ((z->get_sym(h5b)^(z->get_sym(q6b)^(z->get_sym(h1b)^z->get_sym(h2b))))==z->irrep_v()) { 
            long h5b_0,q6b_0,h1b_0,h2b_0; 
            z->restricted_4(h5b,q6b,h1b,h2b,h5b_0,q6b_0,h1b_0,h2b_0); 
            long h3b_1,h4b_1,h5b_1,q6b_1; 
            z->restricted_4(h3b,h4b,h5b,q6b,h3b_1,h4b_1,h5b_1,q6b_1); 
            long dim_common=z->get_range(h5b)*z->get_range(q6b); 
            long dima0_sort=z->get_range(h1b)*z->get_range(h2b); 
            long dima0=dim_common*dima0_sort; 
            long dima1_sort=z->get_range(h3b)*z->get_range(h4b); 
            long dima1=dim_common*dima1_sort; 
            z->v2()->get_block(h2b_0+(z->nab())*(h1b_0+(z->nab())*(q6b_0+(z->nab())*(h5b_0))),k_a0); 
            z->sort_indices4(k_a0,k_a0_sort,z->get_range(h5b),z->get_range(q6b),z->get_range(h1b),z->get_range(h2b),3,2,1,0,+1.0); 
            in[1]->get_block(q6b_1-z->noab()-z->nvab()+z->ncab()*(h5b_1+z->noab()*(h4b_1+z->noab()*(h3b_1))),k_a1); 
            z->sort_indices4(k_a1,k_a1_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(h5b),z->get_range(q6b),1,0,3,2,+1.0); 
            double factor=1.0; 
            z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
           } 
          } 
         } 
        } 
        z->sort_indices4(k_c_sort,k_c,z->get_range(h4b),z->get_range(h3b),z->get_range(h2b),z->get_range(h1b),1,0,3,2,+1.0); 
        out->add_block(h2b+z->noab()*(h1b+z->noab()*(h4b+z->noab()*(h3b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::offset_smith_0_5(){ 
 
long size=0L; 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h5b=0L;h5b<z->noab();++h5b) { 
   for (long q6b=z->noab()+z->nvab();q6b<z->nab();++q6b) { 
    if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h5b)+z->get_spin(q6b)) { 
     if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h5b)^z->get_sym(q6b))))==(z->irrep_t()^z->irrep_e())) { 
      if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h5b)+z->get_spin(q6b)!=8L) { 
       in[1]->input_offset(q6b-z->noab()-z->nvab()+z->ncab()*(h5b+z->noab()*(h4b+z->noab()*(h3b))),size); 
       size+=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h5b)*z->get_range(q6b); 
      } 
     } 
    } 
   } 
  } 
 } 
} 
in[1]->set_filesize(size); 
in[1]->createfile(); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_0_6(Ref<Tensor>& out){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h1b=0L;h1b<z->noab();++h1b) { 
   for (long h2b=0L;h2b<z->noab();++h2b) { 
    long tileoffset; 
    if (h1b<h2b) { 
     tileoffset=(h2b+z->noab()*(h1b+z->noab()*(h4b+z->noab()*(h3b)))); 
    } 
    else if (h2b<=h1b) { 
     tileoffset=(h1b+z->noab()*(h2b+z->noab()*(h4b+z->noab()*(h3b)))); 
    } 
    if (out->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h1b)+z->get_spin(h2b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h1b)^z->get_sym(h2b))))==(z->irrep_t()^z->irrep_e())) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h1b)*z->get_range(h2b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long p5b=z->noab();p5b<z->noab()+z->nvab();++p5b) { 
         if (z->get_spin(p5b)==z->get_spin(h1b)) { 
          if ((z->get_sym(p5b)^z->get_sym(h1b))==z->irrep_t()) { 
           long p5b_0,h1b_0; 
           z->restricted_2(p5b,h1b,p5b_0,h1b_0); 
           long h3b_1,h4b_1,h2b_1,p5b_1; 
           z->restricted_4(h3b,h4b,h2b,p5b,h3b_1,h4b_1,h2b_1,p5b_1); 
           long dim_common=z->get_range(p5b); 
           long dima0_sort=z->get_range(h1b); 
           long dima0=dim_common*dima0_sort; 
           long dima1_sort=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h2b); 
           long dima1=dim_common*dima1_sort; 
           z->t1()->get_block(h1b_0+z->noab()*(p5b_0-z->noab()),k_a0); 
           z->sort_indices2(k_a0,k_a0_sort,z->get_range(p5b),z->get_range(h1b),1,0,+1.0); 
           in[1]->get_block(p5b_1-z->noab()+z->nvab()*(h2b_1+z->noab()*(h4b_1+z->noab()*(h3b_1))),k_a1); 
           z->sort_indices4(k_a1,k_a1_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(h2b),z->get_range(p5b),2,1,0,3,+1.0); 
           double factor=1.0; 
           z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
          } 
         } 
        } 
        if (h2b>=h1b) { 
         z->sort_indices4(k_c_sort,k_c,z->get_range(h2b),z->get_range(h4b),z->get_range(h3b),z->get_range(h1b),2,1,3,0,+1.0); 
         out->add_block(h2b+z->noab()*(h1b+z->noab()*(h4b+z->noab()*(h3b))),k_c); 
        } 
        if (h1b>=h2b) { 
         z->sort_indices4(k_c_sort,k_c,z->get_range(h2b),z->get_range(h4b),z->get_range(h3b),z->get_range(h1b),2,1,0,3,-1.0); 
         out->add_block(h1b+z->noab()*(h2b+z->noab()*(h4b+z->noab()*(h3b))),k_c); 
        } 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_0_6_0(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h2b=0L;h2b<z->noab();++h2b) { 
   for (long p5b=z->noab();p5b<z->noab()+z->nvab();++p5b) { 
    long tileoffset; 
    tileoffset=(p5b-z->noab()+z->nvab()*(h2b+z->noab()*(h4b+z->noab()*(h3b)))); 
    if (in[1]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h2b)+z->get_spin(p5b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h2b)+z->get_spin(p5b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h2b)^z->get_sym(p5b))))==z->irrep_e()) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h2b)*z->get_range(p5b); 
        std::fill(k_c,k_c+dimc,0.0); 
        long h3b_0,h4b_0,h2b_0,p5b_0; 
        z->restricted_4(h3b,h4b,h2b,p5b,h3b_0,h4b_0,h2b_0,p5b_0); 
        long dim_common=1L; 
        long dima0_sort=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h2b)*z->get_range(p5b); 
        long dima0=dim_common*dima0_sort; 
        z->vd2()->get_block(p5b_0+(z->nab())*(h2b_0+(z->nab())*(h4b_0+z->noab()*(h3b_0))),k_a0); 
        z->sort_indices4(k_a0,k_a0_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(h2b),z->get_range(p5b),0,1,2,3,+1.0); 
        z->sort_indices4(k_a0_sort,k_c,z->get_range(h3b),z->get_range(h4b),z->get_range(h2b),z->get_range(p5b),0,1,2,3,-1.0); 
        in[1]->add_block(p5b-z->noab()+z->nvab()*(h2b+z->noab()*(h4b+z->noab()*(h3b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_c); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::offset_smith_0_6(){ 
 
long size=0L; 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h2b=0L;h2b<z->noab();++h2b) { 
   for (long p5b=z->noab();p5b<z->noab()+z->nvab();++p5b) { 
    if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h2b)+z->get_spin(p5b)) { 
     if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h2b)^z->get_sym(p5b))))==(z->irrep_v()^(z->irrep_t()^z->irrep_e()))) { 
      if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h2b)+z->get_spin(p5b)!=8L) { 
       in[1]->input_offset(p5b-z->noab()+z->nvab()*(h2b+z->noab()*(h4b+z->noab()*(h3b))),size); 
       size+=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h2b)*z->get_range(p5b); 
      } 
     } 
    } 
   } 
  } 
 } 
} 
in[1]->set_filesize(size); 
in[1]->createfile(); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_0_9(Ref<Tensor>& out){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h1b=0L;h1b<z->noab();++h1b) { 
   for (long h2b=h1b;h2b<z->noab();++h2b) { 
    long tileoffset; 
    tileoffset=(h2b+z->noab()*(h1b+z->noab()*(h4b+z->noab()*(h3b)))); 
    if (out->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h1b)+z->get_spin(h2b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h1b)^z->get_sym(h2b))))==(z->irrep_e()^(z->irrep_t()^z->irrep_v()))) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h1b)*z->get_range(h2b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long p5b=z->noab();p5b<z->noab()+z->nvab();++p5b) { 
         for (long q6b=z->noab()+z->nvab();q6b<z->nab();++q6b) { 
          if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(p5b)+z->get_spin(q6b)) { 
           if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(p5b)^z->get_sym(q6b))))==z->irrep_e()) { 
            long h3b_0,h4b_0,p5b_0,q6b_0; 
            z->restricted_4(h3b,h4b,p5b,q6b,h3b_0,h4b_0,p5b_0,q6b_0); 
            long p5b_1,q6b_1,h1b_1,h2b_1; 
            z->restricted_4(p5b,q6b,h1b,h2b,p5b_1,q6b_1,h1b_1,h2b_1); 
            long dim_common=z->get_range(p5b)*z->get_range(q6b); 
            long dima0_sort=z->get_range(h3b)*z->get_range(h4b); 
            long dima0=dim_common*dima0_sort; 
            long dima1_sort=z->get_range(h1b)*z->get_range(h2b); 
            long dima1=dim_common*dima1_sort; 
            z->fd2()->get_block(q6b_0+(z->nab())*(p5b_0+(z->nab())*(h4b_0+z->noab()*(h3b_0))),k_a0); 
            z->sort_indices4(k_a0,k_a0_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(p5b),z->get_range(q6b),1,0,3,2,+1.0); 
            in[1]->get_block(h2b_1+z->noab()*(h1b_1+z->noab()*(q6b_1-z->noab()-z->nvab()+z->ncab()*(p5b_1-z->noab()))),k_a1); 
            z->sort_indices4(k_a1,k_a1_sort,z->get_range(p5b),z->get_range(q6b),z->get_range(h1b),z->get_range(h2b),3,2,1,0,+1.0); 
            double factor=1.0; 
            z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
           } 
          } 
         } 
        } 
        z->sort_indices4(k_c_sort,k_c,z->get_range(h2b),z->get_range(h1b),z->get_range(h4b),z->get_range(h3b),3,2,1,0,+1.0); 
        out->add_block(h2b+z->noab()*(h1b+z->noab()*(h4b+z->noab()*(h3b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::offset_smith_0_9(){ 
 
long size=0L; 
for (long p5b=z->noab();p5b<z->noab()+z->nvab();++p5b) { 
 for (long q6b=z->noab()+z->nvab();q6b<z->nab();++q6b) { 
  for (long h1b=0L;h1b<z->noab();++h1b) { 
   for (long h2b=h1b;h2b<z->noab();++h2b) { 
    if (z->get_spin(p5b)+z->get_spin(q6b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
     if ((z->get_sym(p5b)^(z->get_sym(q6b)^(z->get_sym(h1b)^z->get_sym(h2b))))==(z->irrep_t()^z->irrep_v())) { 
      if (!z->restricted() || z->get_spin(p5b)+z->get_spin(q6b)+z->get_spin(h1b)+z->get_spin(h2b)!=8L) { 
       in[1]->input_offset(h2b+z->noab()*(h1b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(p5b-z->noab()))),size); 
       size+=z->get_range(p5b)*z->get_range(q6b)*z->get_range(h1b)*z->get_range(h2b); 
      } 
     } 
    } 
   } 
  } 
 } 
} 
in[1]->set_filesize(size); 
in[1]->createfile(); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_1_1(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long p5b=z->noab();p5b<z->noab()+z->nvab();++p5b) { 
   for (long p6b=z->noab();p6b<z->noab()+z->nvab();++p6b) { 
    long tileoffset; 
    if (p5b<p6b) { 
     tileoffset=(p6b-z->noab()+z->nvab()*(p5b-z->noab()+z->nvab()*(h4b+z->noab()*(h3b)))); 
    } 
    else if (p6b<=p5b) { 
     tileoffset=(p5b-z->noab()+z->nvab()*(p6b-z->noab()+z->nvab()*(h4b+z->noab()*(h3b)))); 
    } 
    if (in[1]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(p5b)+z->get_spin(p6b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(p5b)+z->get_spin(p6b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(p5b)^z->get_sym(p6b))))==(z->irrep_e()^z->irrep_f())) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(p5b)*z->get_range(p6b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long q7b=z->noab()+z->nvab();q7b<z->nab();++q7b) { 
         if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(p5b)+z->get_spin(q7b)) { 
          if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(p5b)^z->get_sym(q7b))))==z->irrep_e()) { 
           long h3b_0,h4b_0,p5b_0,q7b_0; 
           z->restricted_4(h3b,h4b,p5b,q7b,h3b_0,h4b_0,p5b_0,q7b_0); 
           long q7b_1,p6b_1; 
           z->restricted_2(q7b,p6b,q7b_1,p6b_1); 
           long dim_common=z->get_range(q7b); 
           long dima0_sort=z->get_range(h3b)*z->get_range(h4b)*z->get_range(p5b); 
           long dima0=dim_common*dima0_sort; 
           long dima1_sort=z->get_range(p6b); 
           long dima1=dim_common*dima1_sort; 
           z->fd2()->get_block(q7b_0+(z->nab())*(p5b_0+(z->nab())*(h4b_0+z->noab()*(h3b_0))),k_a0); 
           z->sort_indices4(k_a0,k_a0_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(p5b),z->get_range(q7b),2,1,0,3,+1.0); 
           in[2]->get_block(p6b_1-z->noab()+z->nvab()*(q7b_1-z->noab()-z->nvab()),k_a1); 
           z->sort_indices2(k_a1,k_a1_sort,z->get_range(q7b),z->get_range(p6b),1,0,+1.0); 
           double factor=1.0; 
           z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
          } 
         } 
        } 
        if (p6b>=p5b) { 
         z->sort_indices4(k_c_sort,k_c,z->get_range(p6b),z->get_range(p5b),z->get_range(h4b),z->get_range(h3b),3,2,1,0,+1.0); 
         in[1]->add_block(p6b-z->noab()+z->nvab()*(p5b-z->noab()+z->nvab()*(h4b+z->noab()*(h3b))),k_c); 
        } 
        if (p5b>=p6b) { 
         z->sort_indices4(k_c_sort,k_c,z->get_range(p6b),z->get_range(p5b),z->get_range(h4b),z->get_range(h3b),3,2,0,1,-1.0); 
         in[1]->add_block(p5b-z->noab()+z->nvab()*(p6b-z->noab()+z->nvab()*(h4b+z->noab()*(h3b))),k_c); 
        } 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_1_11(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long p5b=z->noab();p5b<z->noab()+z->nvab();++p5b) { 
 for (long q6b=z->noab()+z->nvab();q6b<z->nab();++q6b) { 
  for (long h1b=0L;h1b<z->noab();++h1b) { 
   for (long h2b=h1b;h2b<z->noab();++h2b) { 
    long tileoffset; 
    tileoffset=(h2b+z->noab()*(h1b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(p5b-z->noab())))); 
    if (in[1]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(p5b)+z->get_spin(q6b)+z->get_spin(h1b)+z->get_spin(h2b)!=8L) { 
      if (z->get_spin(p5b)+z->get_spin(q6b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
       if ((z->get_sym(p5b)^(z->get_sym(q6b)^(z->get_sym(h1b)^z->get_sym(h2b))))==(z->irrep_t()^(z->irrep_t()^(z->irrep_t()^z->irrep_v())))) { 
        long dimc=z->get_range(p5b)*z->get_range(q6b)*z->get_range(h1b)*z->get_range(h2b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long h7b=0L;h7b<z->noab();++h7b) { 
         if (z->get_spin(p5b)==z->get_spin(h7b)) { 
          if ((z->get_sym(p5b)^z->get_sym(h7b))==z->irrep_t()) { 
           long p5b_0,h7b_0; 
           z->restricted_2(p5b,h7b,p5b_0,h7b_0); 
           long h7b_1,q6b_1,h1b_1,h2b_1; 
           z->restricted_4(h7b,q6b,h1b,h2b,h7b_1,q6b_1,h1b_1,h2b_1); 
           long dim_common=z->get_range(h7b); 
           long dima0_sort=z->get_range(p5b); 
           long dima0=dim_common*dima0_sort; 
           long dima1_sort=z->get_range(q6b)*z->get_range(h1b)*z->get_range(h2b); 
           long dima1=dim_common*dima1_sort; 
           z->t1()->get_block(h7b_0+z->noab()*(p5b_0-z->noab()),k_a0); 
           z->sort_indices2(k_a0,k_a0_sort,z->get_range(p5b),z->get_range(h7b),0,1,+1.0); 
           in[2]->get_block(h2b_1+z->noab()*(h1b_1+z->noab()*(q6b_1-z->noab()-z->nvab()+z->ncab()*(h7b_1))),k_a1); 
           z->sort_indices4(k_a1,k_a1_sort,z->get_range(h7b),z->get_range(q6b),z->get_range(h1b),z->get_range(h2b),3,2,1,0,+1.0); 
           double factor=1.0; 
           z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
          } 
         } 
        } 
        z->sort_indices4(k_c_sort,k_c,z->get_range(h2b),z->get_range(h1b),z->get_range(q6b),z->get_range(p5b),3,2,1,0,+1.0); 
        in[1]->add_block(h2b+z->noab()*(h1b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(p5b-z->noab()))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::offset_smith_1_11(){ 
 
long size=0L; 
for (long h7b=0L;h7b<z->noab();++h7b) { 
 for (long q6b=z->noab()+z->nvab();q6b<z->nab();++q6b) { 
  for (long h1b=0L;h1b<z->noab();++h1b) { 
   for (long h2b=h1b;h2b<z->noab();++h2b) { 
    if (z->get_spin(h7b)+z->get_spin(q6b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
     if ((z->get_sym(h7b)^(z->get_sym(q6b)^(z->get_sym(h1b)^z->get_sym(h2b))))==(z->irrep_t()^(z->irrep_t()^z->irrep_v()))) { 
      if (!z->restricted() || z->get_spin(h7b)+z->get_spin(q6b)+z->get_spin(h1b)+z->get_spin(h2b)!=8L) { 
       in[2]->input_offset(h2b+z->noab()*(h1b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(h7b))),size); 
       size+=z->get_range(h7b)*z->get_range(q6b)*z->get_range(h1b)*z->get_range(h2b); 
      } 
     } 
    } 
   } 
  } 
 } 
} 
in[2]->set_filesize(size); 
in[2]->createfile(); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_1_14(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long p5b=z->noab();p5b<z->noab()+z->nvab();++p5b) { 
   for (long p6b=p5b;p6b<z->noab()+z->nvab();++p6b) { 
    long tileoffset; 
    tileoffset=(p6b-z->noab()+z->nvab()*(p5b-z->noab()+z->nvab()*(h4b+z->noab()*(h3b)))); 
    if (in[1]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(p5b)+z->get_spin(p6b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(p5b)+z->get_spin(p6b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(p5b)^z->get_sym(p6b))))==(z->irrep_v()^(z->irrep_t()^z->irrep_e()))) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(p5b)*z->get_range(p6b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long h7b=0L;h7b<z->noab();++h7b) { 
         for (long q8b=z->noab()+z->nvab();q8b<z->nab();++q8b) { 
          if (z->get_spin(h7b)+z->get_spin(q8b)==z->get_spin(p5b)+z->get_spin(p6b)) { 
           if ((z->get_sym(h7b)^(z->get_sym(q8b)^(z->get_sym(p5b)^z->get_sym(p6b))))==z->irrep_v()) { 
            long h7b_0,q8b_0,p5b_0,p6b_0; 
            z->restricted_4(h7b,q8b,p5b,p6b,h7b_0,q8b_0,p5b_0,p6b_0); 
            long h3b_1,h4b_1,h7b_1,q8b_1; 
            z->restricted_4(h3b,h4b,h7b,q8b,h3b_1,h4b_1,h7b_1,q8b_1); 
            long dim_common=z->get_range(h7b)*z->get_range(q8b); 
            long dima0_sort=z->get_range(p5b)*z->get_range(p6b); 
            long dima0=dim_common*dima0_sort; 
            long dima1_sort=z->get_range(h3b)*z->get_range(h4b); 
            long dima1=dim_common*dima1_sort; 
            z->v2()->get_block(p6b_0+(z->nab())*(p5b_0+(z->nab())*(q8b_0+(z->nab())*(h7b_0))),k_a0); 
            z->sort_indices4(k_a0,k_a0_sort,z->get_range(h7b),z->get_range(q8b),z->get_range(p5b),z->get_range(p6b),3,2,1,0,+1.0); 
            in[2]->get_block(q8b_1-z->noab()-z->nvab()+z->ncab()*(h7b_1+z->noab()*(h4b_1+z->noab()*(h3b_1))),k_a1); 
            z->sort_indices4(k_a1,k_a1_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(h7b),z->get_range(q8b),1,0,3,2,+1.0); 
            double factor=1.0; 
            z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
           } 
          } 
         } 
        } 
        z->sort_indices4(k_c_sort,k_c,z->get_range(h4b),z->get_range(h3b),z->get_range(p6b),z->get_range(p5b),1,0,3,2,+1.0); 
        in[1]->add_block(p6b-z->noab()+z->nvab()*(p5b-z->noab()+z->nvab()*(h4b+z->noab()*(h3b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::offset_smith_1_14(){ 
 
long size=0L; 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h7b=0L;h7b<z->noab();++h7b) { 
   for (long q8b=z->noab()+z->nvab();q8b<z->nab();++q8b) { 
    if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h7b)+z->get_spin(q8b)) { 
     if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h7b)^z->get_sym(q8b))))==(z->irrep_t()^z->irrep_e())) { 
      if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h7b)+z->get_spin(q8b)!=8L) { 
       in[2]->input_offset(q8b-z->noab()-z->nvab()+z->ncab()*(h7b+z->noab()*(h4b+z->noab()*(h3b))),size); 
       size+=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h7b)*z->get_range(q8b); 
      } 
     } 
    } 
   } 
  } 
 } 
} 
in[2]->set_filesize(size); 
in[2]->createfile(); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_1_1_0(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
for (long q7b=z->noab()+z->nvab();q7b<z->nab();++q7b) { 
 for (long p6b=z->noab();p6b<z->noab()+z->nvab();++p6b) { 
  long tileoffset; 
  tileoffset=(p6b-z->noab()+z->nvab()*(q7b-z->noab()-z->nvab())); 
  if (in[2]->is_this_local(tileoffset)) { 
   if (!z->restricted() || z->get_spin(q7b)+z->get_spin(p6b)!=4L) { 
    if (z->get_spin(q7b)==z->get_spin(p6b)) { 
     if ((z->get_sym(q7b)^z->get_sym(p6b))==z->irrep_f()) { 
      long dimc=z->get_range(q7b)*z->get_range(p6b); 
      std::fill(k_c,k_c+dimc,0.0); 
      long q7b_0,p6b_0; 
      z->restricted_2(q7b,p6b,q7b_0,p6b_0); 
      long dim_common=1L; 
      long dima0_sort=z->get_range(q7b)*z->get_range(p6b); 
      long dima0=dim_common*dima0_sort; 
      z->f1()->get_block(p6b_0+(z->nab())*(q7b_0),k_a0); 
      z->sort_indices2(k_a0,k_a0_sort,z->get_range(q7b),z->get_range(p6b),0,1,+1.0); 
      z->sort_indices2(k_a0_sort,k_c,z->get_range(q7b),z->get_range(p6b),0,1,+1.0); 
      in[2]->add_block(p6b-z->noab()+z->nvab()*(q7b-z->noab()-z->nvab()),k_c); 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_c); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::offset_smith_1_1(){ 
 
long size=0L; 
for (long q7b=z->noab()+z->nvab();q7b<z->nab();++q7b) { 
 for (long p6b=z->noab();p6b<z->noab()+z->nvab();++p6b) { 
  if (z->get_spin(q7b)==z->get_spin(p6b)) { 
   if ((z->get_sym(q7b)^z->get_sym(p6b))==(z->irrep_t()^z->irrep_v())) { 
    if (!z->restricted() || z->get_spin(q7b)+z->get_spin(p6b)!=4L) { 
     in[2]->input_offset(p6b-z->noab()+z->nvab()*(q7b-z->noab()-z->nvab()),size); 
     size+=z->get_range(q7b)*z->get_range(p6b); 
    } 
   } 
  } 
 } 
} 
in[2]->set_filesize(size); 
in[2]->createfile(); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_1_2(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h5b=0L;h5b<z->noab();++h5b) { 
 for (long h6b=h5b;h6b<z->noab();++h6b) { 
  for (long h1b=0L;h1b<z->noab();++h1b) { 
   for (long h2b=0L;h2b<z->noab();++h2b) { 
    long tileoffset; 
    if (h1b<h2b) { 
     tileoffset=(h2b+z->noab()*(h1b+z->noab()*(h6b+z->noab()*(h5b)))); 
    } 
    else if (h2b<=h1b) { 
     tileoffset=(h1b+z->noab()*(h2b+z->noab()*(h6b+z->noab()*(h5b)))); 
    } 
    if (in[1]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h5b)+z->get_spin(h6b)+z->get_spin(h1b)+z->get_spin(h2b)!=8L) { 
      if (z->get_spin(h5b)+z->get_spin(h6b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
       if ((z->get_sym(h5b)^(z->get_sym(h6b)^(z->get_sym(h1b)^z->get_sym(h2b))))==(z->irrep_t()^z->irrep_f())) { 
        long dimc=z->get_range(h5b)*z->get_range(h6b)*z->get_range(h1b)*z->get_range(h2b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long h7b=0L;h7b<z->noab();++h7b) { 
         if (z->get_spin(h5b)+z->get_spin(h6b)==z->get_spin(h1b)+z->get_spin(h7b)) { 
          if ((z->get_sym(h5b)^(z->get_sym(h6b)^(z->get_sym(h1b)^z->get_sym(h7b))))==z->irrep_t()) { 
           long h5b_0,h6b_0,h1b_0,h7b_0; 
           z->restricted_4(h5b,h6b,h1b,h7b,h5b_0,h6b_0,h1b_0,h7b_0); 
           long h7b_1,h2b_1; 
           z->restricted_2(h7b,h2b,h7b_1,h2b_1); 
           long dim_common=z->get_range(h7b); 
           long dima0_sort=z->get_range(h5b)*z->get_range(h6b)*z->get_range(h1b); 
           long dima0=dim_common*dima0_sort; 
           long dima1_sort=z->get_range(h2b); 
           long dima1=dim_common*dima1_sort; 
           if (h1b<h7b) { 
            z->gt2()->get_block(h7b_0+z->noab()*(h1b_0+z->noab()*(h6b_0+z->noab()*(h5b_0))),k_a0); 
            z->sort_indices4(k_a0,k_a0_sort,z->get_range(h5b),z->get_range(h6b),z->get_range(h1b),z->get_range(h7b),2,1,0,3,+1.0); 
           } 
           else if (h7b<=h1b) { 
            z->gt2()->get_block(h1b_0+z->noab()*(h7b_0+z->noab()*(h6b_0+z->noab()*(h5b_0))),k_a0); 
            z->sort_indices4(k_a0,k_a0_sort,z->get_range(h5b),z->get_range(h6b),z->get_range(h7b),z->get_range(h1b),3,1,0,2,-1.0); 
           } 
           z->f1()->get_block(h2b_1+(z->nab())*(h7b_1),k_a1); 
           z->sort_indices2(k_a1,k_a1_sort,z->get_range(h7b),z->get_range(h2b),1,0,+1.0); 
           double factor=1.0; 
           z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
          } 
         } 
        } 
        if (h2b>=h1b) { 
         z->sort_indices4(k_c_sort,k_c,z->get_range(h2b),z->get_range(h1b),z->get_range(h6b),z->get_range(h5b),3,2,1,0,-1.0); 
         in[1]->add_block(h2b+z->noab()*(h1b+z->noab()*(h6b+z->noab()*(h5b))),k_c); 
        } 
        if (h1b>=h2b) { 
         z->sort_indices4(k_c_sort,k_c,z->get_range(h2b),z->get_range(h1b),z->get_range(h6b),z->get_range(h5b),3,2,0,1,+1.0); 
         in[1]->add_block(h1b+z->noab()*(h2b+z->noab()*(h6b+z->noab()*(h5b))),k_c); 
        } 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_1_5(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h5b=0L;h5b<z->noab();++h5b) { 
   for (long q6b=z->noab()+z->nvab();q6b<z->nab();++q6b) { 
    long tileoffset; 
    tileoffset=(q6b-z->noab()-z->nvab()+z->ncab()*(h5b+z->noab()*(h4b+z->noab()*(h3b)))); 
    if (in[1]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h5b)+z->get_spin(q6b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h5b)+z->get_spin(q6b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h5b)^z->get_sym(q6b))))==(z->irrep_t()^z->irrep_e())) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h5b)*z->get_range(q6b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long p7b=z->noab();p7b<z->noab()+z->nvab();++p7b) { 
         if (z->get_spin(p7b)==z->get_spin(h5b)) { 
          if ((z->get_sym(p7b)^z->get_sym(h5b))==z->irrep_t()) { 
           long p7b_0,h5b_0; 
           z->restricted_2(p7b,h5b,p7b_0,h5b_0); 
           long h3b_1,h4b_1,p7b_1,q6b_1; 
           z->restricted_4(h3b,h4b,p7b,q6b,h3b_1,h4b_1,p7b_1,q6b_1); 
           long dim_common=z->get_range(p7b); 
           long dima0_sort=z->get_range(h5b); 
           long dima0=dim_common*dima0_sort; 
           long dima1_sort=z->get_range(h3b)*z->get_range(h4b)*z->get_range(q6b); 
           long dima1=dim_common*dima1_sort; 
           z->t1()->get_block(h5b_0+z->noab()*(p7b_0-z->noab()),k_a0); 
           z->sort_indices2(k_a0,k_a0_sort,z->get_range(p7b),z->get_range(h5b),1,0,+1.0); 
           z->fd2()->get_block(q6b_1+(z->nab())*(p7b_1+(z->nab())*(h4b_1+z->noab()*(h3b_1))),k_a1); 
           z->sort_indices4(k_a1,k_a1_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(p7b),z->get_range(q6b),3,1,0,2,+1.0); 
           double factor=1.0; 
           z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
          } 
         } 
        } 
        z->sort_indices4(k_c_sort,k_c,z->get_range(q6b),z->get_range(h4b),z->get_range(h3b),z->get_range(h5b),2,1,3,0,-1.0); 
        in[1]->add_block(q6b-z->noab()-z->nvab()+z->ncab()*(h5b+z->noab()*(h4b+z->noab()*(h3b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_1_7(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h2b=0L;h2b<z->noab();++h2b) { 
   for (long p5b=z->noab();p5b<z->noab()+z->nvab();++p5b) { 
    long tileoffset; 
    tileoffset=(p5b-z->noab()+z->nvab()*(h2b+z->noab()*(h4b+z->noab()*(h3b)))); 
    if (in[1]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h2b)+z->get_spin(p5b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h2b)+z->get_spin(p5b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h2b)^z->get_sym(p5b))))==(z->irrep_v()^(z->irrep_t()^z->irrep_e()))) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h2b)*z->get_range(p5b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long h6b=0L;h6b<z->noab();++h6b) { 
         for (long q7b=z->noab()+z->nvab();q7b<z->nab();++q7b) { 
          if (z->get_spin(h6b)+z->get_spin(q7b)==z->get_spin(h2b)+z->get_spin(p5b)) { 
           if ((z->get_sym(h6b)^(z->get_sym(q7b)^(z->get_sym(h2b)^z->get_sym(p5b))))==z->irrep_v()) { 
            long h6b_0,q7b_0,h2b_0,p5b_0; 
            z->restricted_4(h6b,q7b,h2b,p5b,h6b_0,q7b_0,h2b_0,p5b_0); 
            long h3b_1,h4b_1,h6b_1,q7b_1; 
            z->restricted_4(h3b,h4b,h6b,q7b,h3b_1,h4b_1,h6b_1,q7b_1); 
            long dim_common=z->get_range(h6b)*z->get_range(q7b); 
            long dima0_sort=z->get_range(h2b)*z->get_range(p5b); 
            long dima0=dim_common*dima0_sort; 
            long dima1_sort=z->get_range(h3b)*z->get_range(h4b); 
            long dima1=dim_common*dima1_sort; 
            z->v2()->get_block(p5b_0+(z->nab())*(h2b_0+(z->nab())*(q7b_0+(z->nab())*(h6b_0))),k_a0); 
            z->sort_indices4(k_a0,k_a0_sort,z->get_range(h6b),z->get_range(q7b),z->get_range(h2b),z->get_range(p5b),3,2,1,0,+1.0); 
            in[2]->get_block(q7b_1-z->noab()-z->nvab()+z->ncab()*(h6b_1+z->noab()*(h4b_1+z->noab()*(h3b_1))),k_a1); 
            z->sort_indices4(k_a1,k_a1_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(h6b),z->get_range(q7b),1,0,3,2,+1.0); 
            double factor=1.0; 
            z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
           } 
          } 
         } 
        } 
        z->sort_indices4(k_c_sort,k_c,z->get_range(h4b),z->get_range(h3b),z->get_range(p5b),z->get_range(h2b),1,0,3,2,+1.0); 
        in[1]->add_block(p5b-z->noab()+z->nvab()*(h2b+z->noab()*(h4b+z->noab()*(h3b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::offset_smith_1_7(){ 
 
long size=0L; 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h6b=0L;h6b<z->noab();++h6b) { 
   for (long q7b=z->noab()+z->nvab();q7b<z->nab();++q7b) { 
    if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h6b)+z->get_spin(q7b)) { 
     if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h6b)^z->get_sym(q7b))))==(z->irrep_t()^z->irrep_e())) { 
      if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h6b)+z->get_spin(q7b)!=8L) { 
       in[2]->input_offset(q7b-z->noab()-z->nvab()+z->ncab()*(h6b+z->noab()*(h4b+z->noab()*(h3b))),size); 
       size+=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h6b)*z->get_range(q7b); 
      } 
     } 
    } 
   } 
  } 
 } 
} 
in[2]->set_filesize(size); 
in[2]->createfile(); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_1_8(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h2b=0L;h2b<z->noab();++h2b) { 
   for (long p5b=z->noab();p5b<z->noab()+z->nvab();++p5b) { 
    long tileoffset; 
    tileoffset=(p5b-z->noab()+z->nvab()*(h2b+z->noab()*(h4b+z->noab()*(h3b)))); 
    if (in[1]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h2b)+z->get_spin(p5b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h2b)+z->get_spin(p5b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h2b)^z->get_sym(p5b))))==(z->irrep_t()^z->irrep_e())) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h2b)*z->get_range(p5b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long p6b=z->noab();p6b<z->noab()+z->nvab();++p6b) { 
         if (z->get_spin(p6b)==z->get_spin(h2b)) { 
          if ((z->get_sym(p6b)^z->get_sym(h2b))==z->irrep_t()) { 
           long p6b_0,h2b_0; 
           z->restricted_2(p6b,h2b,p6b_0,h2b_0); 
           long h3b_1,h4b_1,p5b_1,p6b_1; 
           z->restricted_4(h3b,h4b,p5b,p6b,h3b_1,h4b_1,p5b_1,p6b_1); 
           long dim_common=z->get_range(p6b); 
           long dima0_sort=z->get_range(h2b); 
           long dima0=dim_common*dima0_sort; 
           long dima1_sort=z->get_range(h3b)*z->get_range(h4b)*z->get_range(p5b); 
           long dima1=dim_common*dima1_sort; 
           z->t1()->get_block(h2b_0+z->noab()*(p6b_0-z->noab()),k_a0); 
           z->sort_indices2(k_a0,k_a0_sort,z->get_range(p6b),z->get_range(h2b),1,0,+1.0); 
           if (p5b<p6b) { 
            z->vd2()->get_block(p6b_1+(z->nab())*(p5b_1+(z->nab())*(h4b_1+z->noab()*(h3b_1))),k_a1); 
            z->sort_indices4(k_a1,k_a1_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(p5b),z->get_range(p6b),2,1,0,3,+1.0); 
           } 
           else if (p6b<=p5b) { 
            z->vd2()->get_block(p5b_1+(z->nab())*(p6b_1+(z->nab())*(h4b_1+z->noab()*(h3b_1))),k_a1); 
            z->sort_indices4(k_a1,k_a1_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(p6b),z->get_range(p5b),3,1,0,2,-1.0); 
           } 
           double factor=1.0; 
           z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
          } 
         } 
        } 
        z->sort_indices4(k_c_sort,k_c,z->get_range(p5b),z->get_range(h4b),z->get_range(h3b),z->get_range(h2b),2,1,3,0,+0.5); 
        in[1]->add_block(p5b-z->noab()+z->nvab()*(h2b+z->noab()*(h4b+z->noab()*(h3b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_1_9(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long p5b=z->noab();p5b<z->noab()+z->nvab();++p5b) { 
 for (long q6b=z->noab()+z->nvab();q6b<z->nab();++q6b) { 
  for (long h1b=0L;h1b<z->noab();++h1b) { 
   for (long h2b=0L;h2b<z->noab();++h2b) { 
    long tileoffset; 
    if (h1b<h2b) { 
     tileoffset=(h2b+z->noab()*(h1b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(p5b-z->noab())))); 
    } 
    else if (h2b<=h1b) { 
     tileoffset=(h1b+z->noab()*(h2b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(p5b-z->noab())))); 
    } 
    if (in[1]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(p5b)+z->get_spin(q6b)+z->get_spin(h1b)+z->get_spin(h2b)!=8L) { 
      if (z->get_spin(p5b)+z->get_spin(q6b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
       if ((z->get_sym(p5b)^(z->get_sym(q6b)^(z->get_sym(h1b)^z->get_sym(h2b))))==(z->irrep_t()^z->irrep_v())) { 
        long dimc=z->get_range(p5b)*z->get_range(q6b)*z->get_range(h1b)*z->get_range(h2b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long h8b=0L;h8b<z->noab();++h8b) { 
         for (long p7b=z->noab();p7b<z->noab()+z->nvab();++p7b) { 
          if (z->get_spin(p5b)+z->get_spin(p7b)==z->get_spin(h1b)+z->get_spin(h8b)) { 
           if ((z->get_sym(p5b)^(z->get_sym(p7b)^(z->get_sym(h1b)^z->get_sym(h8b))))==z->irrep_t()) { 
            long p5b_0,p7b_0,h1b_0,h8b_0; 
            z->restricted_4(p5b,p7b,h1b,h8b,p5b_0,p7b_0,h1b_0,h8b_0); 
            long h8b_1,q6b_1,h2b_1,p7b_1; 
            z->restricted_4(h8b,q6b,h2b,p7b,h8b_1,q6b_1,h2b_1,p7b_1); 
            long dim_common=z->get_range(h8b)*z->get_range(p7b); 
            long dima0_sort=z->get_range(p5b)*z->get_range(h1b); 
            long dima0=dim_common*dima0_sort; 
            long dima1_sort=z->get_range(q6b)*z->get_range(h2b); 
            long dima1=dim_common*dima1_sort; 
            if (p5b<p7b && h1b<h8b) { 
             z->t2()->get_block(h8b_0+z->noab()*(h1b_0+z->noab()*(p7b_0-z->noab()+z->nvab()*(p5b_0-z->noab()))),k_a0); 
             z->sort_indices4(k_a0,k_a0_sort,z->get_range(p5b),z->get_range(p7b),z->get_range(h1b),z->get_range(h8b),2,0,1,3,+1.0); 
            } 
            else if (p5b<p7b && h8b<=h1b) { 
             z->t2()->get_block(h1b_0+z->noab()*(h8b_0+z->noab()*(p7b_0-z->noab()+z->nvab()*(p5b_0-z->noab()))),k_a0); 
             z->sort_indices4(k_a0,k_a0_sort,z->get_range(p5b),z->get_range(p7b),z->get_range(h8b),z->get_range(h1b),3,0,1,2,-1.0); 
            } 
            else if (p7b<=p5b && h1b<h8b) { 
             z->t2()->get_block(h8b_0+z->noab()*(h1b_0+z->noab()*(p5b_0-z->noab()+z->nvab()*(p7b_0-z->noab()))),k_a0); 
             z->sort_indices4(k_a0,k_a0_sort,z->get_range(p7b),z->get_range(p5b),z->get_range(h1b),z->get_range(h8b),2,1,0,3,-1.0); 
            } 
            else if (p7b<=p5b && h8b<=h1b) { 
             z->t2()->get_block(h1b_0+z->noab()*(h8b_0+z->noab()*(p5b_0-z->noab()+z->nvab()*(p7b_0-z->noab()))),k_a0); 
             z->sort_indices4(k_a0,k_a0_sort,z->get_range(p7b),z->get_range(p5b),z->get_range(h8b),z->get_range(h1b),3,1,0,2,+1.0); 
            } 
            in[2]->get_block(p7b_1-z->noab()+z->nvab()*(h2b_1+z->noab()*(q6b_1-z->noab()-z->nvab()+z->ncab()*(h8b_1))),k_a1); 
            z->sort_indices4(k_a1,k_a1_sort,z->get_range(h8b),z->get_range(q6b),z->get_range(h2b),z->get_range(p7b),2,1,3,0,+1.0); 
            double factor=1.0; 
            z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
           } 
          } 
         } 
        } 
        if (h2b>=h1b) { 
         z->sort_indices4(k_c_sort,k_c,z->get_range(h2b),z->get_range(q6b),z->get_range(h1b),z->get_range(p5b),3,1,2,0,+1.0); 
         in[1]->add_block(h2b+z->noab()*(h1b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(p5b-z->noab()))),k_c); 
        } 
        if (h1b>=h2b) { 
         z->sort_indices4(k_c_sort,k_c,z->get_range(h2b),z->get_range(q6b),z->get_range(h1b),z->get_range(p5b),3,1,0,2,-1.0); 
         in[1]->add_block(h1b+z->noab()*(h2b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(p5b-z->noab()))),k_c); 
        } 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_1_9_0(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h8b=0L;h8b<z->noab();++h8b) { 
 for (long q6b=z->noab()+z->nvab();q6b<z->nab();++q6b) { 
  for (long h2b=0L;h2b<z->noab();++h2b) { 
   for (long p7b=z->noab();p7b<z->noab()+z->nvab();++p7b) { 
    long tileoffset; 
    tileoffset=(p7b-z->noab()+z->nvab()*(h2b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(h8b)))); 
    if (in[2]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h8b)+z->get_spin(q6b)+z->get_spin(h2b)+z->get_spin(p7b)!=8L) { 
      if (z->get_spin(h8b)+z->get_spin(q6b)==z->get_spin(h2b)+z->get_spin(p7b)) { 
       if ((z->get_sym(h8b)^(z->get_sym(q6b)^(z->get_sym(h2b)^z->get_sym(p7b))))==z->irrep_v()) { 
        long dimc=z->get_range(h8b)*z->get_range(q6b)*z->get_range(h2b)*z->get_range(p7b); 
        std::fill(k_c,k_c+dimc,0.0); 
        long h8b_0,q6b_0,h2b_0,p7b_0; 
        z->restricted_4(h8b,q6b,h2b,p7b,h8b_0,q6b_0,h2b_0,p7b_0); 
        long dim_common=1L; 
        long dima0_sort=z->get_range(h8b)*z->get_range(q6b)*z->get_range(h2b)*z->get_range(p7b); 
        long dima0=dim_common*dima0_sort; 
        z->v2()->get_block(p7b_0+(z->nab())*(h2b_0+(z->nab())*(q6b_0+(z->nab())*(h8b_0))),k_a0); 
        z->sort_indices4(k_a0,k_a0_sort,z->get_range(h8b),z->get_range(q6b),z->get_range(h2b),z->get_range(p7b),0,1,2,3,+1.0); 
        z->sort_indices4(k_a0_sort,k_c,z->get_range(h8b),z->get_range(q6b),z->get_range(h2b),z->get_range(p7b),0,1,2,3,-1.0); 
        in[2]->add_block(p7b-z->noab()+z->nvab()*(h2b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(h8b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_c); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::offset_smith_1_9(){ 
 
long size=0L; 
for (long h8b=0L;h8b<z->noab();++h8b) { 
 for (long q6b=z->noab()+z->nvab();q6b<z->nab();++q6b) { 
  for (long h2b=0L;h2b<z->noab();++h2b) { 
   for (long p7b=z->noab();p7b<z->noab()+z->nvab();++p7b) { 
    if (z->get_spin(h8b)+z->get_spin(q6b)==z->get_spin(h2b)+z->get_spin(p7b)) { 
     if ((z->get_sym(h8b)^(z->get_sym(q6b)^(z->get_sym(h2b)^z->get_sym(p7b))))==(z->irrep_t()^z->irrep_v())) { 
      if (!z->restricted() || z->get_spin(h8b)+z->get_spin(q6b)+z->get_spin(h2b)+z->get_spin(p7b)!=8L) { 
       in[2]->input_offset(p7b-z->noab()+z->nvab()*(h2b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(h8b))),size); 
       size+=z->get_range(h8b)*z->get_range(q6b)*z->get_range(h2b)*z->get_range(p7b); 
      } 
     } 
    } 
   } 
  } 
 } 
} 
in[2]->set_filesize(size); 
in[2]->createfile(); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_2_11(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h7b=0L;h7b<z->noab();++h7b) { 
 for (long q6b=z->noab()+z->nvab();q6b<z->nab();++q6b) { 
  for (long h1b=0L;h1b<z->noab();++h1b) { 
   for (long h2b=0L;h2b<z->noab();++h2b) { 
    long tileoffset; 
    if (h1b<h2b) { 
     tileoffset=(h2b+z->noab()*(h1b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(h7b)))); 
    } 
    else if (h2b<=h1b) { 
     tileoffset=(h1b+z->noab()*(h2b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(h7b)))); 
    } 
    if (in[2]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h7b)+z->get_spin(q6b)+z->get_spin(h1b)+z->get_spin(h2b)!=8L) { 
      if (z->get_spin(h7b)+z->get_spin(q6b)==z->get_spin(h1b)+z->get_spin(h2b)) { 
       if ((z->get_sym(h7b)^(z->get_sym(q6b)^(z->get_sym(h1b)^z->get_sym(h2b))))==(z->irrep_t()^(z->irrep_t()^z->irrep_v()))) { 
        long dimc=z->get_range(h7b)*z->get_range(q6b)*z->get_range(h1b)*z->get_range(h2b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long p8b=z->noab();p8b<z->noab()+z->nvab();++p8b) { 
         if (z->get_spin(p8b)==z->get_spin(h1b)) { 
          if ((z->get_sym(p8b)^z->get_sym(h1b))==z->irrep_t()) { 
           long p8b_0,h1b_0; 
           z->restricted_2(p8b,h1b,p8b_0,h1b_0); 
           long h7b_1,q6b_1,h2b_1,p8b_1; 
           z->restricted_4(h7b,q6b,h2b,p8b,h7b_1,q6b_1,h2b_1,p8b_1); 
           long dim_common=z->get_range(p8b); 
           long dima0_sort=z->get_range(h1b); 
           long dima0=dim_common*dima0_sort; 
           long dima1_sort=z->get_range(h7b)*z->get_range(q6b)*z->get_range(h2b); 
           long dima1=dim_common*dima1_sort; 
           z->t1()->get_block(h1b_0+z->noab()*(p8b_0-z->noab()),k_a0); 
           z->sort_indices2(k_a0,k_a0_sort,z->get_range(p8b),z->get_range(h1b),1,0,+1.0); 
           in[3]->get_block(p8b_1-z->noab()+z->nvab()*(h2b_1+z->noab()*(q6b_1-z->noab()-z->nvab()+z->ncab()*(h7b_1))),k_a1); 
           z->sort_indices4(k_a1,k_a1_sort,z->get_range(h7b),z->get_range(q6b),z->get_range(h2b),z->get_range(p8b),2,1,0,3,+1.0); 
           double factor=1.0; 
           z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
          } 
         } 
        } 
        if (h2b>=h1b) { 
         z->sort_indices4(k_c_sort,k_c,z->get_range(h2b),z->get_range(q6b),z->get_range(h7b),z->get_range(h1b),2,1,3,0,+1.0); 
         in[2]->add_block(h2b+z->noab()*(h1b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(h7b))),k_c); 
        } 
        if (h1b>=h2b) { 
         z->sort_indices4(k_c_sort,k_c,z->get_range(h2b),z->get_range(q6b),z->get_range(h7b),z->get_range(h1b),2,1,0,3,-1.0); 
         in[2]->add_block(h1b+z->noab()*(h2b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(h7b))),k_c); 
        } 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::offset_smith_2_11(){ 
 
long size=0L; 
for (long h7b=0L;h7b<z->noab();++h7b) { 
 for (long q6b=z->noab()+z->nvab();q6b<z->nab();++q6b) { 
  for (long h2b=0L;h2b<z->noab();++h2b) { 
   for (long p8b=z->noab();p8b<z->noab()+z->nvab();++p8b) { 
    if (z->get_spin(h7b)+z->get_spin(q6b)==z->get_spin(h2b)+z->get_spin(p8b)) { 
     if ((z->get_sym(h7b)^(z->get_sym(q6b)^(z->get_sym(h2b)^z->get_sym(p8b))))==(z->irrep_t()^z->irrep_v())) { 
      if (!z->restricted() || z->get_spin(h7b)+z->get_spin(q6b)+z->get_spin(h2b)+z->get_spin(p8b)!=8L) { 
       in[3]->input_offset(p8b-z->noab()+z->nvab()*(h2b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(h7b))),size); 
       size+=z->get_range(h7b)*z->get_range(q6b)*z->get_range(h2b)*z->get_range(p8b); 
      } 
     } 
    } 
   } 
  } 
 } 
} 
in[3]->set_filesize(size); 
in[3]->createfile(); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_2_12(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
for (long q7b=z->noab()+z->nvab();q7b<z->nab();++q7b) { 
 for (long p6b=z->noab();p6b<z->noab()+z->nvab();++p6b) { 
  long tileoffset; 
  tileoffset=(p6b-z->noab()+z->nvab()*(q7b-z->noab()-z->nvab())); 
  if (in[2]->is_this_local(tileoffset)) { 
   if (!z->restricted() || z->get_spin(q7b)+z->get_spin(p6b)!=4L) { 
    if (z->get_spin(q7b)==z->get_spin(p6b)) { 
     if ((z->get_sym(q7b)^z->get_sym(p6b))==(z->irrep_t()^z->irrep_v())) { 
      long dimc=z->get_range(q7b)*z->get_range(p6b); 
      std::fill(k_c_sort,k_c_sort+dimc,0.0); 
      for (long h9b=0L;h9b<z->noab();++h9b) { 
       for (long p8b=z->noab();p8b<z->noab()+z->nvab();++p8b) { 
        if (z->get_spin(p8b)==z->get_spin(h9b)) { 
         if ((z->get_sym(p8b)^z->get_sym(h9b))==z->irrep_t()) { 
          long p8b_0,h9b_0; 
          z->restricted_2(p8b,h9b,p8b_0,h9b_0); 
          long h9b_1,q7b_1,p6b_1,p8b_1; 
          z->restricted_4(h9b,q7b,p6b,p8b,h9b_1,q7b_1,p6b_1,p8b_1); 
          long dim_common=z->get_range(h9b)*z->get_range(p8b); 
          long dima0_sort=1L; 
          long dima0=dim_common*dima0_sort; 
          long dima1_sort=z->get_range(q7b)*z->get_range(p6b); 
          long dima1=dim_common*dima1_sort; 
          z->t1()->get_block(h9b_0+z->noab()*(p8b_0-z->noab()),k_a0); 
          z->sort_indices2(k_a0,k_a0_sort,z->get_range(p8b),z->get_range(h9b),0,1,+1.0); 
          if (p6b<p8b) { 
           z->v2()->get_block(p8b_1+(z->nab())*(p6b_1+(z->nab())*(q7b_1+(z->nab())*(h9b_1))),k_a1); 
           z->sort_indices4(k_a1,k_a1_sort,z->get_range(h9b),z->get_range(q7b),z->get_range(p6b),z->get_range(p8b),2,1,3,0,+1.0); 
          } 
          else if (p8b<=p6b) { 
           z->v2()->get_block(p6b_1+(z->nab())*(p8b_1+(z->nab())*(q7b_1+(z->nab())*(h9b_1))),k_a1); 
           z->sort_indices4(k_a1,k_a1_sort,z->get_range(h9b),z->get_range(q7b),z->get_range(p8b),z->get_range(p6b),3,1,2,0,-1.0); 
          } 
          double factor=1.0; 
          z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
         } 
        } 
       } 
      } 
      z->sort_indices2(k_c_sort,k_c,z->get_range(p6b),z->get_range(q7b),1,0,-1.0); 
      in[2]->add_block(p6b-z->noab()+z->nvab()*(q7b-z->noab()-z->nvab()),k_c); 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_2_13(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h8b=0L;h8b<z->noab();++h8b) { 
 for (long q6b=z->noab()+z->nvab();q6b<z->nab();++q6b) { 
  for (long h2b=0L;h2b<z->noab();++h2b) { 
   for (long p7b=z->noab();p7b<z->noab()+z->nvab();++p7b) { 
    long tileoffset; 
    tileoffset=(p7b-z->noab()+z->nvab()*(h2b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(h8b)))); 
    if (in[2]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h8b)+z->get_spin(q6b)+z->get_spin(h2b)+z->get_spin(p7b)!=8L) { 
      if (z->get_spin(h8b)+z->get_spin(q6b)==z->get_spin(h2b)+z->get_spin(p7b)) { 
       if ((z->get_sym(h8b)^(z->get_sym(q6b)^(z->get_sym(h2b)^z->get_sym(p7b))))==(z->irrep_t()^z->irrep_v())) { 
        long dimc=z->get_range(h8b)*z->get_range(q6b)*z->get_range(h2b)*z->get_range(p7b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long p9b=z->noab();p9b<z->noab()+z->nvab();++p9b) { 
         if (z->get_spin(p9b)==z->get_spin(h2b)) { 
          if ((z->get_sym(p9b)^z->get_sym(h2b))==z->irrep_t()) { 
           long p9b_0,h2b_0; 
           z->restricted_2(p9b,h2b,p9b_0,h2b_0); 
           long h8b_1,q6b_1,p7b_1,p9b_1; 
           z->restricted_4(h8b,q6b,p7b,p9b,h8b_1,q6b_1,p7b_1,p9b_1); 
           long dim_common=z->get_range(p9b); 
           long dima0_sort=z->get_range(h2b); 
           long dima0=dim_common*dima0_sort; 
           long dima1_sort=z->get_range(h8b)*z->get_range(q6b)*z->get_range(p7b); 
           long dima1=dim_common*dima1_sort; 
           z->t1()->get_block(h2b_0+z->noab()*(p9b_0-z->noab()),k_a0); 
           z->sort_indices2(k_a0,k_a0_sort,z->get_range(p9b),z->get_range(h2b),1,0,+1.0); 
           if (p7b<p9b) { 
            z->v2()->get_block(p9b_1+(z->nab())*(p7b_1+(z->nab())*(q6b_1+(z->nab())*(h8b_1))),k_a1); 
            z->sort_indices4(k_a1,k_a1_sort,z->get_range(h8b),z->get_range(q6b),z->get_range(p7b),z->get_range(p9b),2,1,0,3,+1.0); 
           } 
           else if (p9b<=p7b) { 
            z->v2()->get_block(p7b_1+(z->nab())*(p9b_1+(z->nab())*(q6b_1+(z->nab())*(h8b_1))),k_a1); 
            z->sort_indices4(k_a1,k_a1_sort,z->get_range(h8b),z->get_range(q6b),z->get_range(p9b),z->get_range(p7b),3,1,0,2,-1.0); 
           } 
           double factor=1.0; 
           z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
          } 
         } 
        } 
        z->sort_indices4(k_c_sort,k_c,z->get_range(p7b),z->get_range(q6b),z->get_range(h8b),z->get_range(h2b),2,1,3,0,+1.0); 
        in[2]->add_block(p7b-z->noab()+z->nvab()*(h2b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(h8b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_2_14(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h7b=0L;h7b<z->noab();++h7b) { 
   for (long q8b=z->noab()+z->nvab();q8b<z->nab();++q8b) { 
    long tileoffset; 
    tileoffset=(q8b-z->noab()-z->nvab()+z->ncab()*(h7b+z->noab()*(h4b+z->noab()*(h3b)))); 
    if (in[2]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h7b)+z->get_spin(q8b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h7b)+z->get_spin(q8b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h7b)^z->get_sym(q8b))))==(z->irrep_t()^z->irrep_e())) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h7b)*z->get_range(q8b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long p9b=z->noab();p9b<z->noab()+z->nvab();++p9b) { 
         if (z->get_spin(p9b)==z->get_spin(h7b)) { 
          if ((z->get_sym(p9b)^z->get_sym(h7b))==z->irrep_t()) { 
           long p9b_0,h7b_0; 
           z->restricted_2(p9b,h7b,p9b_0,h7b_0); 
           long h3b_1,h4b_1,p9b_1,q8b_1; 
           z->restricted_4(h3b,h4b,p9b,q8b,h3b_1,h4b_1,p9b_1,q8b_1); 
           long dim_common=z->get_range(p9b); 
           long dima0_sort=z->get_range(h7b); 
           long dima0=dim_common*dima0_sort; 
           long dima1_sort=z->get_range(h3b)*z->get_range(h4b)*z->get_range(q8b); 
           long dima1=dim_common*dima1_sort; 
           z->t1()->get_block(h7b_0+z->noab()*(p9b_0-z->noab()),k_a0); 
           z->sort_indices2(k_a0,k_a0_sort,z->get_range(p9b),z->get_range(h7b),1,0,+1.0); 
           z->fd2()->get_block(q8b_1+(z->nab())*(p9b_1+(z->nab())*(h4b_1+z->noab()*(h3b_1))),k_a1); 
           z->sort_indices4(k_a1,k_a1_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(p9b),z->get_range(q8b),3,1,0,2,+1.0); 
           double factor=1.0; 
           z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
          } 
         } 
        } 
        z->sort_indices4(k_c_sort,k_c,z->get_range(q8b),z->get_range(h4b),z->get_range(h3b),z->get_range(h7b),2,1,3,0,-1.0); 
        in[2]->add_block(q8b-z->noab()-z->nvab()+z->ncab()*(h7b+z->noab()*(h4b+z->noab()*(h3b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_2_7(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h3b=0L;h3b<z->noab();++h3b) { 
 for (long h4b=h3b;h4b<z->noab();++h4b) { 
  for (long h6b=0L;h6b<z->noab();++h6b) { 
   for (long q7b=z->noab()+z->nvab();q7b<z->nab();++q7b) { 
    long tileoffset; 
    tileoffset=(q7b-z->noab()-z->nvab()+z->ncab()*(h6b+z->noab()*(h4b+z->noab()*(h3b)))); 
    if (in[2]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h3b)+z->get_spin(h4b)+z->get_spin(h6b)+z->get_spin(q7b)!=8L) { 
      if (z->get_spin(h3b)+z->get_spin(h4b)==z->get_spin(h6b)+z->get_spin(q7b)) { 
       if ((z->get_sym(h3b)^(z->get_sym(h4b)^(z->get_sym(h6b)^z->get_sym(q7b))))==(z->irrep_t()^z->irrep_e())) { 
        long dimc=z->get_range(h3b)*z->get_range(h4b)*z->get_range(h6b)*z->get_range(q7b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long p8b=z->noab();p8b<z->noab()+z->nvab();++p8b) { 
         if (z->get_spin(p8b)==z->get_spin(h6b)) { 
          if ((z->get_sym(p8b)^z->get_sym(h6b))==z->irrep_t()) { 
           long p8b_0,h6b_0; 
           z->restricted_2(p8b,h6b,p8b_0,h6b_0); 
           long h3b_1,h4b_1,p8b_1,q7b_1; 
           z->restricted_4(h3b,h4b,p8b,q7b,h3b_1,h4b_1,p8b_1,q7b_1); 
           long dim_common=z->get_range(p8b); 
           long dima0_sort=z->get_range(h6b); 
           long dima0=dim_common*dima0_sort; 
           long dima1_sort=z->get_range(h3b)*z->get_range(h4b)*z->get_range(q7b); 
           long dima1=dim_common*dima1_sort; 
           z->t1()->get_block(h6b_0+z->noab()*(p8b_0-z->noab()),k_a0); 
           z->sort_indices2(k_a0,k_a0_sort,z->get_range(p8b),z->get_range(h6b),1,0,+1.0); 
           z->fd2()->get_block(q7b_1+(z->nab())*(p8b_1+(z->nab())*(h4b_1+z->noab()*(h3b_1))),k_a1); 
           z->sort_indices4(k_a1,k_a1_sort,z->get_range(h3b),z->get_range(h4b),z->get_range(p8b),z->get_range(q7b),3,1,0,2,+1.0); 
           double factor=1.0; 
           z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
          } 
         } 
        } 
        z->sort_indices4(k_c_sort,k_c,z->get_range(q7b),z->get_range(h4b),z->get_range(h3b),z->get_range(h6b),2,1,3,0,+1.0); 
        in[2]->add_block(q7b-z->noab()-z->nvab()+z->ncab()*(h6b+z->noab()*(h4b+z->noab()*(h3b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
  
void CCSDPR12_C::smith_3_11(){ 
      
double* k_a0=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a0_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()); 
double* k_a1=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_a1_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
double* k_c_sort=z->mem()->malloc_local_double(z->maxtilesize()*z->maxtilesize()*z->maxtilesize()*z->maxtilesize()); 
for (long h7b=0L;h7b<z->noab();++h7b) { 
 for (long q6b=z->noab()+z->nvab();q6b<z->nab();++q6b) { 
  for (long h2b=0L;h2b<z->noab();++h2b) { 
   for (long p8b=z->noab();p8b<z->noab()+z->nvab();++p8b) { 
    long tileoffset; 
    tileoffset=(p8b-z->noab()+z->nvab()*(h2b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(h7b)))); 
    if (in[3]->is_this_local(tileoffset)) { 
     if (!z->restricted() || z->get_spin(h7b)+z->get_spin(q6b)+z->get_spin(h2b)+z->get_spin(p8b)!=8L) { 
      if (z->get_spin(h7b)+z->get_spin(q6b)==z->get_spin(h2b)+z->get_spin(p8b)) { 
       if ((z->get_sym(h7b)^(z->get_sym(q6b)^(z->get_sym(h2b)^z->get_sym(p8b))))==(z->irrep_t()^z->irrep_v())) { 
        long dimc=z->get_range(h7b)*z->get_range(q6b)*z->get_range(h2b)*z->get_range(p8b); 
        std::fill(k_c_sort,k_c_sort+dimc,0.0); 
        for (long p9b=z->noab();p9b<z->noab()+z->nvab();++p9b) { 
         if (z->get_spin(p9b)==z->get_spin(h2b)) { 
          if ((z->get_sym(p9b)^z->get_sym(h2b))==z->irrep_t()) { 
           long p9b_0,h2b_0; 
           z->restricted_2(p9b,h2b,p9b_0,h2b_0); 
           long h7b_1,q6b_1,p8b_1,p9b_1; 
           z->restricted_4(h7b,q6b,p8b,p9b,h7b_1,q6b_1,p8b_1,p9b_1); 
           long dim_common=z->get_range(p9b); 
           long dima0_sort=z->get_range(h2b); 
           long dima0=dim_common*dima0_sort; 
           long dima1_sort=z->get_range(h7b)*z->get_range(q6b)*z->get_range(p8b); 
           long dima1=dim_common*dima1_sort; 
           z->t1()->get_block(h2b_0+z->noab()*(p9b_0-z->noab()),k_a0); 
           z->sort_indices2(k_a0,k_a0_sort,z->get_range(p9b),z->get_range(h2b),1,0,+1.0); 
           if (p8b<p9b) { 
            z->v2()->get_block(p9b_1+(z->nab())*(p8b_1+(z->nab())*(q6b_1+(z->nab())*(h7b_1))),k_a1); 
            z->sort_indices4(k_a1,k_a1_sort,z->get_range(h7b),z->get_range(q6b),z->get_range(p8b),z->get_range(p9b),2,1,0,3,+1.0); 
           } 
           else if (p9b<=p8b) { 
            z->v2()->get_block(p8b_1+(z->nab())*(p9b_1+(z->nab())*(q6b_1+(z->nab())*(h7b_1))),k_a1); 
            z->sort_indices4(k_a1,k_a1_sort,z->get_range(h7b),z->get_range(q6b),z->get_range(p9b),z->get_range(p8b),3,1,0,2,-1.0); 
           } 
           double factor=1.0; 
           z->smith_dgemm(dima0_sort,dima1_sort,dim_common,factor,k_a0_sort,dim_common,k_a1_sort,dim_common,1.0,k_c_sort,dima0_sort); 
          } 
         } 
        } 
        z->sort_indices4(k_c_sort,k_c,z->get_range(p8b),z->get_range(q6b),z->get_range(h7b),z->get_range(h2b),2,1,3,0,-0.5); 
        in[3]->add_block(p8b-z->noab()+z->nvab()*(h2b+z->noab()*(q6b-z->noab()-z->nvab()+z->ncab()*(h7b))),k_c); 
       } 
      } 
     } 
    } 
   } 
  } 
 } 
} 
z->mem()->free_local_double(k_a1_sort); 
z->mem()->free_local_double(k_a1); 
z->mem()->free_local_double(k_a0_sort); 
z->mem()->free_local_double(k_a0); 
z->mem()->free_local_double(k_c_sort); 
z->mem()->free_local_double(k_c); 
z->mem()->sync(); 
} 
